/*===========================================================================
		M88 for PocketPC
		Original Version (c)cisc
		Pocket PC Version Programmed by Y.Taniuchi ( TAN-Y )

		ݒ_CAONX
===========================================================================*/

#include "m88ce.h"



/*---------------------------------------------------------------------------
		RXgN^
---------------------------------------------------------------------------*/

CConfigDialog::CConfigDialog( int iPageCnt, PC8801::Config *pConfig,
								CDiskImageManager *pDiskImageManager )
{
	m_pConfig = pConfig;
	m_iPageCnt = iPageCnt;
	m_pDiskImageManager = pDiskImageManager;

	m_phPSPs = new HPROPSHEETPAGE[iPageCnt];
}


/*---------------------------------------------------------------------------
		fXgN^
---------------------------------------------------------------------------*/

CConfigDialog::~CConfigDialog()
{
	if( m_phPSPs != NULL )
	{
		delete[] m_phPSPs;
	}

	m_phPSPs = NULL;
}


/*---------------------------------------------------------------------------
		_CAOtO擾
---------------------------------------------------------------------------*/

DWORD CConfigDialog::GetDialogFlag()
{
	return PSH_NOAPPLYNOW;
}


/*---------------------------------------------------------------------------
		\
---------------------------------------------------------------------------*/

int CConfigDialog::Show( HWND hWndParent )
{
PROPSHEETHEADER pspheader;


	if( InitPSP( m_phPSPs ) == false )
	{
		return -1;
	}

	pspheader.dwSize = sizeof( PROPSHEETHEADER );
	pspheader.dwFlags = GetDialogFlag() | PSH_USECALLBACK;
	pspheader.hwndParent = hWndParent;
	pspheader.hInstance = _Module.GetResourceInstance();
	pspheader.pszIcon = NULL;
	pspheader.pszCaption = _T("M88/wm5 Configuration");
	pspheader.nPages = m_iPageCnt;
	pspheader.nStartPage = 0;
	pspheader.phpage = m_phPSPs;
	pspheader.pfnCallback = PropSheetCallback;

	InitPSPHeader( &pspheader );

//	::SetWindowLong( hWndParent, GWL_STYLE, WS_VISIBLE | WS_OVERLAPPED );
	int iRetCode = ::PropertySheet( &pspheader );
//	::SetWindowLong( hWndParent, GWL_STYLE, WS_VISIBLE | WS_POPUP );

	return iRetCode;
}


/*---------------------------------------------------------------------------
		R[obN
---------------------------------------------------------------------------*/

int CALLBACK CConfigDialog::PropSheetCallback(HWND hWnd,
											UINT uMsg, LPARAM lParam)
{

#ifdef PSCB_GETVERSION
	switch( uMsg )
	{
		//
		//	H/PC̓_?
		//
		case PSCB_GETVERSION:
		{
			return COMCTL32_VERSION;
		}
	}
#endif

	return 0;
}



