/*===========================================================================
		GAPI p\tgEGAL[{[hNX

		M88 for WindowsMobile5.0 by NNK
		based on PocketPC Version by Y.Taniuchi ( TAN-Y )
===========================================================================*/

#ifndef _INC_TANY_SOFTKEYBOARD_VGA
#define _INC_TANY_SOFTKEYBOARD_VGA

struct KeyInfo
{
	long m_lPosX;		//	L[\ʒu X
	long m_lPosY;		//	L[\ʒu Y
	long m_lViewIndex;	//	̃p[^ɎOɃAhXvZĊi[

	LPCSTR szKeyTopNorm;		//	L[gbviʏj
	LPCSTR szKeyTopNormShift;	//	L[gbviʏVtgj
	LPCSTR szKeyTopKana;		//	L[gbviJij
	LPCSTR szKeyTopKanaShift;	//	L[gbviJiVtgj
};


#define KEYSTATUS_BUFSIZE 128

class CGAPISoftKeybVga
{
private:

	GXDisplayProperties m_gxdp;
	long m_lKeybXPos;		//	L[{[h\ʒuXWiۂ̃|Ps̍Wj
	long m_lKeybYPos;		//	L[{[h\ʒuYWiۂ̃|Ps̍Wj
	long m_lViewIndex;		//	L[{[h\ʒuւ̃CfbNX
	long m_lXIndex;			//	ꕶ̃̕CfbNXl
	WORD m_wPixel;			//	gpsNZf[^
	WORD m_wPixelRightBar;	//	L[E[EF

	bool m_blLockedCaps;
	bool m_blLockedKana;
	bool m_blLockedShiftLock;
	bool m_blPressedShift;

	void PutFont( LPBYTE pDst, unsigned char ucCode, bool blPressed,
					bool blDrawRightBar );
	void PutKeytop( LPBYTE pDst, int iKeytopCode );

	bool m_pblPressedKeys[KEYSTATUS_BUFSIZE];
	bool m_pblDrawKeys[KEYSTATUS_BUFSIZE];

public:
	CGAPISoftKeybVga( long lXPos, long lYPos, const GXDisplayProperties *pGxdp,
					WORD wPixel, WORD wPixelRightBar );

	int GetKeytopCode( WORD wXPos, WORD wYPos );

	void Redraw( LPBYTE pDst );
	void Draw( LPBYTE pDst );

	void InitKeyTbl( void );

	void KeyUp( int iKeyCode );
	void KeyDown( int iKeyCode );

	bool GetPressedStatus( int iIndex )
	{
		return m_pblPressedKeys[iIndex];
	}
};



#endif
