/*============================================================================
		TAN-Y Library 4 for Visual C++ Ver.6.0 (Win32)
		RACu

		XbhNX
		Copyright & Programmed by Y.Taniuchi( TAN-Y )
============================================================================*/

//#include "tl4sys.h"
#include "headers.h"
#include "CThread.h"

namespace tl4
{	//	start namespace


/*----------------------------------------------------------------------------
		RXgN^
		 IRunnable NXIuWFNgւ̃|C^ݒ肷ƁA
		Xbh̏͂ōsB
		iXbh𑀍삷IuWFNgƎ؂藣j
----------------------------------------------------------------------------*/

CThread::CThread( IRunnable *pRunnable )
{
	m_dwThreadId = 0;
	m_hThread = NULL;
	m_pRunnable = pRunnable;
}


/*----------------------------------------------------------------------------
		fXgN^
----------------------------------------------------------------------------*/

CThread::~CThread()
{
	Close();
}


/*----------------------------------------------------------------------------
		XbhJn
			dwCreationFlags		Xbh̃tOݒ
		߂l	BOOL				FALSE ͂łɃXbh쒆
									łȂꍇ
----------------------------------------------------------------------------*/

BOOL CThread::Start( DWORD dwCreationFlags )
{
LPVOID pObj = (LPVOID)this;

	if( IsRunning() )
	{
		return FALSE;
	}

	if( m_pRunnable != NULL )
	{
		pObj = (LPVOID)m_pRunnable;
	}

	m_hThread = CreateThread( NULL, 0,
							(LPTHREAD_START_ROUTINE)ThreadHook,
							pObj, dwCreationFlags,
							&m_dwThreadId );
	if( m_hThread == FALSE )
	{
		m_hThread = NULL;
		m_dwThreadId = 0;
		return	FALSE;
	}
	return	TRUE;
}


/*----------------------------------------------------------------------------
		Xbhnh
		߂l	BOOL			TRUE ŐIB
								FALSE ̓nh NULL B
----------------------------------------------------------------------------*/

BOOL CThread::Close()
{
	if( m_hThread == NULL )
	{
		return	FALSE;
	}
	CloseHandle( m_hThread );
	m_hThread = NULL;
	m_dwThreadId = 0;

	return	TRUE;
}


/*----------------------------------------------------------------------------
		Xbh~
			dwExitCode		XbhIR[h
		߂l	BOOL			TRUE ŐIB
								FALSE ̓Xbh삵ĂȂB
----------------------------------------------------------------------------*/

BOOL CThread::Terminate( DWORD dwExitCode )
{

	if( IsRunning() )
	{
		TerminateThread( m_hThread, dwExitCode );
		Close();
		return	TRUE;
	}
	return	FALSE;
}


/*----------------------------------------------------------------------------
		Xbh̓mF
		߂l	BOOL			TRUE ŃXbh쒆
----------------------------------------------------------------------------*/

BOOL CThread::IsRunning()
{
DWORD	dwGetExitCode;
BOOL	bResult;

	bResult = GetExitCodeThread( m_hThread, &dwGetExitCode );
	if( bResult && dwGetExitCode == STILL_ACTIVE )
	{
		return	TRUE;
	}

	Close();
	return	FALSE;
}


/*----------------------------------------------------------------------------
		IRunnable ̋
		CThread ̃RXgN^̈ȗ邩 NULL ݒ肵ꍇ
		ƂKvB
----------------------------------------------------------------------------*/

DWORD CThread::Run()
{
	return 0;
}


}	//	end namespace
